/* ------------------------------------------------------------------
                               mcs_gpio.h
                                (MCS-51)

     weisst den Portpins Makros zum Setzen und Loeschen einzelner
     Portbits zu oder deklariert einen Portpin als Eingang.

     Da der MCS51 Bitmanipulationen auf den Ports beherscht waeren
     diese Makros unnoetig, sie wurden deklariert, um kompatibel mit
     anderen MCU's zu sein.

     Setzen und loeschen eines Portpins am Beispiel P2_0

     Setzen eines Portpins geschieht mit: P2_0_set()
                            loeschen mit: P2_0_clr()

     Lesen eines Portpins am Beispiel P2_1

     Portpin als Eingang anmelden:  P2_1_input_init()
               lesen des Portpins:  a= is_P2_1()


     21.01.2018    R. Seelig

   ------------------------------------------------------------------- */

#ifndef in_gpio
  #define in_gpio

  // #######################################
  //   Fuer Port0
  // #######################################

  #define P0_0_set()           (P0_0 = 1)
  #define P0_0_clr()           (P0_0 = 0)
  #define P0_0_input_init()    (P0_0 = 1)
  #define is_P0_0()             P0_0

  #define P0_1_set()           (P0_1 = 1)
  #define P0_1_clr()           (P0_1 = 0)
  #define P0_1_input_init()    (P0_1 = 1)
  #define is_P0_1()             P0_1

  #define P0_2_set()           (P0_2 = 1)
  #define P0_2_clr()           (P0_2 = 0)
  #define P0_2_input_init()    (P0_2 = 1)
  #define is_P0_2()             P0_2

  #define P0_3_set()           (P0_3 = 1)
  #define P0_3_clr()           (P0_3 = 0)
  #define P0_3_input_init()    (P0_3 = 1)
  #define is_P0_3()             P0_3

  #define P0_4_set()           (P0_4 = 1)
  #define P0_4_clr()           (P0_4 = 0)
  #define P0_4_input_init()    (P0_4 = 1)
  #define is_P0_4()             P0_4

  #define P0_5_set()           (P0_5 = 1)
  #define P0_5_clr()           (P0_5 = 0)
  #define P0_5_input_init()    (P0_5 = 1)
  #define is_P0_5()             P0_5

  #define P0_6_set()           (P0_6 = 1)
  #define P0_6_clr()           (P0_6 = 0)
  #define P0_6_input_init()    (P0_6 = 1)
  #define is_P0_6()             P0_6

  #define P0_7_set()           (P0_7 = 1)
  #define P0_7_clr()           (P0_7 = 0)
  #define P0_7_input_init()    (P0_7 = 1)
  #define is_P0_7()             P0_7

  // #######################################
  //   Fuer Port1
  // #######################################

  #define P1_0_set()           (P1_0 = 1)
  #define P1_0_clr()           (P1_0 = 0)
  #define P1_0_input_init()    (P1_0 = 1)
  #define is_P1_0()             P1_0

  #define P1_1_set()           (P1_1 = 1)
  #define P1_1_clr()           (P1_1 = 0)
  #define P1_1_input_init()    (P1_1 = 1)
  #define is_P1_1()             P1_1

  #define P1_2_set()           (P1_2 = 1)
  #define P1_2_clr()           (P1_2 = 0)
  #define P1_2_input_init()    (P1_2 = 1)
  #define is_P1_2()             P1_2

  #define P1_3_set()           (P1_3 = 1)
  #define P1_3_clr()           (P1_3 = 0)
  #define P1_3_input_init()    (P1_3 = 1)
  #define is_P1_3()             P1_3

  #define P1_4_set()           (P1_4 = 1)
  #define P1_4_clr()           (P1_4 = 0)
  #define P1_4_input_init()    (P1_4 = 1)
  #define is_P1_4()             P1_4

  #define P1_5_set()           (P1_5 = 1)
  #define P1_5_clr()           (P1_5 = 0)
  #define P1_5_input_init()    (P1_5 = 1)
  #define is_P1_5()             P1_5

  #define P1_6_set()           (P1_6 = 1)
  #define P1_6_clr()           (P1_6 = 0)
  #define P1_6_input_init()    (P1_6 = 1)
  #define is_P1_6()             P1_6

  #define P1_7_set()           (P1_7 = 1)
  #define P1_7_clr()           (P1_7 = 0)
  #define P1_7_input_init()    (P1_7 = 1)
  #define is_P1_7()             P1_7


  // #######################################
  //   Fuer Port2
  // #######################################


  #define P2_0_set()           (P2_0 = 1)
  #define P2_0_clr()           (P2_0 = 0)
  #define P2_0_input_init()    (P2_0 = 1)
  #define is_P2_0()             P2_0

  #define P2_1_set()           (P2_1 = 1)
  #define P2_1_clr()           (P2_1 = 0)
  #define P2_1_input_init()    (P2_1 = 1)
  #define is_P2_1()             P2_1

  #define P2_2_set()           (P2_2 = 1)
  #define P2_2_clr()           (P2_2 = 0)
  #define P2_2_input_init()    (P2_2 = 1)
  #define is_P2_2()             P2_2

  #define P2_3_set()           (P2_3 = 1)
  #define P2_3_clr()           (P2_3 = 0)
  #define P2_3_input_init()    (P2_3 = 1)
  #define is_P2_3()             P2_3

  #define P2_4_set()           (P2_4 = 1)
  #define P2_4_clr()           (P2_4 = 0)
  #define P2_4_input_init()    (P2_4 = 1)
  #define is_P2_4()             P2_4

  #define P2_5_set()           (P2_5 = 1)
  #define P2_5_clr()           (P2_5 = 0)
  #define P2_5_input_init()    (P2_5 = 1)
  #define is_P2_5()             P2_5

  #define P2_6_set()           (P2_6 = 1)
  #define P2_6_clr()           (P2_6 = 0)
  #define P2_6_input_init()    (P2_6 = 1)
  #define is_P2_6()             P2_6

  #define P2_7_set()           (P2_7 = 1)
  #define P2_7_clr()           (P2_7 = 0)
  #define P2_7_input_init()    (P2_7 = 1)
  #define is_P2_7()             P2_7

  // #######################################
  //   Fuer Port3
  // #######################################


  #define P3_0_set()           (P3_0 = 1)
  #define P3_0_clr()           (P3_0 = 0)
  #define P3_0_input_init()    (P3_0 = 1)
  #define is_P3_0()             P3_0

  #define P3_1_set()           (P3_1 = 1)
  #define P3_1_clr()           (P3_1 = 0)
  #define P3_1_input_init()    (P3_1 = 1)
  #define is_P3_1()             P3_1

  #define P3_2_set()           (P3_2 = 1)
  #define P3_2_clr()           (P3_2 = 0)
  #define P3_2_input_init()    (P3_2 = 1)
  #define is_P3_2()             P3_2

  #define P3_3_set()           (P3_3 = 1)
  #define P3_3_clr()           (P3_3 = 0)
  #define P3_3_input_init()    (P3_3 = 1)
  #define is_P3_3()             P3_3

  #define P3_4_set()           (P3_4 = 1)
  #define P3_4_clr()           (P3_4 = 0)
  #define P3_4_input_init()    (P3_4 = 1)
  #define is_P3_4()             P3_4

  #define P3_5_set()           (P3_5 = 1)
  #define P3_5_clr()           (P3_5 = 0)
  #define P3_5_input_init()    (P3_5 = 1)
  #define is_P3_5()             P3_5

  #define P3_6_set()           (P3_6 = 1)
  #define P3_6_clr()           (P3_6 = 0)
  #define P3_6_input_init()    (P3_6 = 1)
  #define is_P3_6()             P3_6

  #define P3_7_set()           (P3_7 = 1)
  #define P3_7_clr()           (P3_7 = 0)
  #define P3_7_input_init()    (P3_7 = 1)
  #define is_P3_7()             P3_7

#endif